#
# Conditional build:
%bcond_with	tests		# unit tests (supported only using bazel)
%bcond_without	static_libs	# static libraries
#
Summary:	Google C++ testing framework
Summary(pl.UTF-8):	Szkielet testów w C++ stworzony przez Google
Name:		gtest
Version:	1.17.0
Release:	1
License:	BSD
Group:		Development/Tools
#Source0Download: https://github.com/google/googletest/releases
Source0:	https://github.com/google/googletest/archive/v%{version}/googletest-%{version}.tar.gz
# Source0-md5:	b6f100bc2a5853a48046aa168ececf84
Patch0:		cmake.patch
URL:		https://github.com/google/googletest
BuildRequires:	cmake >= 3.13
BuildRequires:	libstdc++-devel >= 6:7
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Google's framework for writing C++ tests on a variety of platforms
(GNU/Linux, Mac OS X, Windows, Windows CE, and Symbian). Based on the
xUnit architecture. Supports automatic test discovery, a rich set of
assertions, user-defined assertions, death tests, fatal and non-fatal
failures, various options for running the tests, and XML test report
generation.

%description -l pl.UTF-8
Stworzony przez Google szkielet do pisania testów w C++ na różnych
platformach (GNU/Linux, Mac OS X, Windows, Windows CE, Symbian). Jest
oparty na architekturze xUnit. Obsługuje automatyczne wykrywanie
testów, bogaty zbiór zapewnień, zapewnienia zdefiniowane przez
użytkownika, testy śmierci, niepowodzenia krytyczne i niekrytyczne,
różne opcje uruchamiania testów oraz tworzenie raportów z testów w
XML-u.

%package devel
Summary:	Development files for gtest framework
Summary(pl.UTF-8):	Pliki programistyczne szkieletu gtest
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel >= 6:7

%description devel
This package contains development files for gtest framework.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki programistyczne szkieletu gtest.

%package static
Summary:	Static gtest libraries
Summary(pl.UTF-8):	Statyczne biblioteki gtest
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static gtest libraries.

%description static -l pl.UTF-8
Statyczne biblioteki gtest.

%package src
Summary:	Source code of gtest framework
Summary(pl.UTF-8):	Kod źródłowy szkieletu gtest
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description src
Source code of gtest framework for embedding it in other projects.

%description src -l pl.UTF-8
Kod źródłowy szkieletu gtest do osadzania go w innych projektach.

%package -n gmock
Summary:	Google C++ Mocking Framework
Summary(pl.UTF-8):	Szkielet Google Mock dla C++
Group:		Libraries
Requires:	gtest = %{version}-%{release}

%description -n gmock
Inspired by jMock, EasyMock, and Hamcrest, and designed with C++'s
specifics in mind, Google C++ Mocking Framework (or Google Mock for
short) is a library for writing and using C++ mock classes.

Google Mock:
- lets you create mock classes trivially using simple macros,
- supports a rich set of matchers and actions,
- handles unordered, partially ordered, or completely ordered
  expectations,
- is extensible by users, and
- works on Linux, Mac OS X, Windows, Windows Mobile, minGW, and
  Symbian.

%description -n gmock -l pl.UTF-8
Google C++ Mocking Framework (w skrócie Google Mock) to zainspirowana
przez jMock, EasyMock i Hamcrest, zaprojektowana z myślą o specyfice
C++ biblioteka do pisania i wykorzystywania klas "mock" w C++.

Google Mock:
- pozwala tworzyć klasy "mock" w sposób trywialny przy użyciu makr;
- obsługuje bogaty zbiór dopasowań i akcji;
- obsługuje oczekiwania nieuporządkowane, częściowo uporządkowane
  lub w pełni uporządkowane;
- jest rozszerzalna dla użytkownika;
- działa na Linuksie, Mac OS X, Windows, Windows Mobile, minGW oraz
  Symbianie.

%package -n gmock-devel
Summary:	Development files for gmock framework
Summary(pl.UTF-8):	Pliki programistyczne szkieletu gmock
Group:		Development/Libraries
Requires:	gmock = %{version}-%{release}
Requires:	gtest-devel = %{version}-%{release}

%description -n gmock-devel
This package contains development files for gmock framework.

%description -n gmock-devel -l pl.UTF-8
Ten pakiet zawiera pliki programistyczne szkieletu gmock.

%package -n gmock-static
Summary:	Static gmock libraries
Summary(pl.UTF-8):	Statyczne biblioteki gmock
Group:		Development/Libraries
Requires:	gmock-devel = %{version}-%{release}

%description -n gmock-static
Static gmock libraries.

%description -n gmock-static -l pl.UTF-8
Statyczne biblioteki gmock.

%package -n gmock-src
Summary:	Source code of gmock framework
Summary(pl.UTF-8):	Kod źródłowy szkieletu gmock
Group:		Development/Libraries
Requires:	%{name}-src = %{version}-%{release}
Requires:	gmock-devel = %{version}-%{release}

%description -n gmock-src
Source code of gmock framework for embedding it in other projects.

%description -n gmock-src -l pl.UTF-8
Kod źródłowy szkieletu gmock do osadzania go w innych projektach.

%prep
%setup -q -n googletest-%{version}
%patch -P0 -p1

%build
# Note: official build system is now Bazel - but it's extremely distro unfriendly.
# Use unofficial, community maintained CMake suite.
# Force C++17 for std::string_view support.
%if %{with static_libs}
%cmake -B build-static \
	-DBUILD_SHARED_LIBS=OFF \
	-DCMAKE_CXX_STANDARD=17

%{__make} -C build-static
%endif

%cmake -B build \
	-DCMAKE_CXX_STANDARD=17

%{__make} -C build

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C build-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_prefix}/src/gtest
cp -pr googletest/{cmake,src,CMakeLists.txt} $RPM_BUILD_ROOT%{_prefix}/src/gtest
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -p googletest/samples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

install -d $RPM_BUILD_ROOT%{_prefix}/src/gmock
cp -pr googlemock/{cmake,src,CMakeLists.txt} $RPM_BUILD_ROOT%{_prefix}/src/gmock
# gmock CMakeLists.txt expects gtest or ../googletest accessile
ln -snf ../gtest $RPM_BUILD_ROOT%{_prefix}/src/gmock/gtest

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc googletest/README.md
%attr(755,root,root) %{_libdir}/libgtest.so.*.*.*
%attr(755,root,root) %{_libdir}/libgtest_main.so.*.*.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgtest.so
%attr(755,root,root) %{_libdir}/libgtest_main.so
%{_includedir}/gtest
%{_pkgconfigdir}/gtest.pc
%{_pkgconfigdir}/gtest_main.pc
%{_libdir}/cmake/GTest
%{_examplesdir}/%{name}-%{version}

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libgtest.a
%{_libdir}/libgtest_main.a
%endif

%files src
%defattr(644,root,root,755)
%{_prefix}/src/gtest

%files -n gmock
%defattr(644,root,root,755)
%doc googlemock/README.md
%attr(755,root,root) %{_libdir}/libgmock.so.*.*.*
%attr(755,root,root) %{_libdir}/libgmock_main.so.*.*.*

%files -n gmock-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgmock.so
%attr(755,root,root) %{_libdir}/libgmock_main.so
%{_includedir}/gmock
%{_pkgconfigdir}/gmock.pc
%{_pkgconfigdir}/gmock_main.pc

%if %{with static_libs}
%files -n gmock-static
%defattr(644,root,root,755)
%{_libdir}/libgmock.a
%{_libdir}/libgmock_main.a
%endif

%files -n gmock-src
%defattr(644,root,root,755)
%{_prefix}/src/gmock
%changelog
* Thu Jun 05 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gtest.git;a=log;h=master

* Thu Jun 05 2025 Jakub Bogusz <qboosh@pld-linux.org> 511297e
- updated to 1.17.0

* Thu Jun 05 2025 Jakub Bogusz <qboosh@pld-linux.org> ac645b4
- use patch -P

* Mon Sep 09 2024 Jakub Bogusz <qboosh@pld-linux.org> a5d1a96
- updated to 1.15.2, force C++17 for std::string_view support

* Sat Dec 16 2023 Jakub Bogusz <qboosh@pld-linux.org> dc2ed1e
- updated to 1.14.0

* Sun Mar 05 2023 Jakub Bogusz <qboosh@pld-linux.org> a42fbcb
- updated to 1.13.0, requires C++ 14 now

* Tue Jan 17 2023 Jakub Bogusz <qboosh@pld-linux.org> 471f594
- updated to 1.12.1; gtest-config and gmock generator are gone

* Mon Feb 14 2022 Jan Rękorajski <baggins@pld-linux.org> a154caf
- fix broken cmakefiles, rel 3

* Wed Dec 01 2021 Jan Rękorajski <baggins@pld-linux.org> 9522e4a
- update install and files, rel 2

* Wed Dec 01 2021 Jan Rękorajski <baggins@pld-linux.org> 5bfb48e
- remove obsolete patch

* Wed Dec 01 2021 Jan Rękorajski <baggins@pld-linux.org> dc95659
- up to 1.11.0

* Thu Mar 05 2020 Jakub Bogusz <qboosh@pld-linux.org> 197e2f8
- updated to 1.10.0
- removed outdated install,link,gmock-install,version patches; autotools support is now gone
- switched to unofficial cmake support (bazel is hard to get it to work in PLD)
- added libversion patch to install versioned libraries
- try to package built libgmock, might be usable now
- gtest and gmock sources moved to *-src packages

* Sat Oct 27 2018 Jakub Bogusz <qboosh@pld-linux.org> 14c3ca6
- package gtest .pc files; release 3

* Tue Oct 16 2018 Jakub Bogusz <qboosh@pld-linux.org> b0f58fc
- added version patch: clean up versioning mess; release 2

* Fri Oct 12 2018 Jakub Bogusz <qboosh@pld-linux.org> d85ab48
- updated to 1.8.1

* Mon Dec 26 2016 Jakub Bogusz <qboosh@pld-linux.org> a8131d9
- fix installed gmock/gtest integration by creating gtest symlink; release 2

* Sun Sep 25 2016 Jakub Bogusz <qboosh@pld-linux.org> a774437
- new Source0 URL, updated to 1.8.0; now merged with gmock

* Wed Apr 13 2016 Jakub Bogusz <qboosh@pld-linux.org> 8154102
- updated URLs

* Sat Nov 21 2015 Jan Rękorajski <baggins@pld-linux.org> 3258869
- release 5 (by relup.sh)

* Sun Sep 20 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 4780a74
- release 4 (by relup.sh)

* Fri Feb 27 2015 Elan Ruusamäe <glen@delfi.ee> 9135e61
- x32 rebuild
- release 3 (by relup.sh)

